Bug 961298

Summary: [hi_IN] Gnu free fonts rendering issues in gnome-shell
Product: [Fedora] Fedora Reporter: Pravin Satpute <psatpute>
Component: gnu-free-fontsAssignee: Jon Ciesla <limburgher>
Status: CLOSED ERRATA QA Contact: Fedora Extras Quality Assurance <extras-qa>
Severity: unspecified Docs Contact:
Priority: unspecified    
Version: 19CC: fonts-bugs, i18n-bugs, limburgher, mclasen, mshao, orion, pnemade, psatpute, Stevan_White, tagoh
Target Milestone: ---Keywords: i18n
Target Release: ---   
Hardware: Unspecified   
OS: Unspecified   
Whiteboard:
Fixed In Version: gnu-free-fonts-20120503-7.fc19 Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of: 956192 Environment:
Last Closed: 2013-07-02 21:42:41 EDT Type: Bug
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Attachments:
Description Flags
patch to fix rendering issue. none

Description Pravin Satpute 2013-05-09 07:24:22 EDT
+++ This bug was initially created as a clone of Bug #956192 +++

Description of problem:
Rendering of Text in Gnome-shell (and gedit) is broken. (May need to move bug for harfbuzz or pango?). but working as expected with Search (with gnome-shell), and Run dialog (Alt+f2)

example Text [क्रियाएँ]


Version-Release number of selected component (if applicable):
lohit-devanagari-fonts-2.5.3-2.fc19.noarch

gnu-free-sans-fonts-20120503-5.fc19.noarch
gnu-free-fonts-common-20120503-5.fc19.noarch
gnu-free-mono-fonts-20120503-5.fc19.noarch
gnu-free-serif-fonts-20120503-5.fc19.noarch

How reproducible:


Steps to Reproduce:
1. Login into Hindi Desktop
2. Check "Acitivies" Rendering
3. Copy (क्रियाएँ) Text
4. Paste in Gedit
5. Press Window (Super) Key and Paste Text in Search
6. Alt + F2 and paste Copied text
7. Run firefox and Paste copied text

Actual results:
Rendering is wrong in step 2 (gnome-shell), 4 (gedit), 


Expected results:
Rendering is correct for Step 5, 6, 7

Additional info:
1. If remove gnu-free-* fonts from system, rendering is fine
2. Bug #918478 is already fixed, but still issue is there for Rendering.



Few more results from terminal on desktop
1.
-
LANG=hi_IN.utf8
LC_CTYPE="hi_IN.utf8"
LC_NUMERIC="hi_IN.utf8"
LC_TIME="hi_IN.utf8"
LC_COLLATE="hi_IN.utf8"
LC_MONETARY="hi_IN.utf8"
LC_MESSAGES="hi_IN.utf8"
LC_PAPER="hi_IN.utf8"
LC_NAME="hi_IN.utf8"
LC_ADDRESS="hi_IN.utf8"
LC_TELEPHONE="hi_IN.utf8"
LC_MEASUREMENT="hi_IN.utf8"
LC_IDENTIFICATION="hi_IN.utf8"
LC_ALL=
--
2
-
[hindi@lenovox230 ~]$ fc-match 
Lohit-Devanagari.ttf: "Lohit Devanagari" "Regular"
[hindi@lenovox230 ~]$ fc-match :lang=hi
Lohit-Devanagari.ttf: "Lohit Devanagari" "Regular"
[hindi@lenovox230 ~]$ fc-match :lang=mr
Lohit-Devanagari.ttf: "Lohit Devanagari" "Regular"
---

--- Additional comment from Jon Ciesla on 2013-04-25 00:15:45 IST ---

If it's not occurring everywhere, I'm not convinced the bug is with the fonts, but with something farther down.  Could you attach a screenshot(s) with examples?

--- Additional comment from A S Alam on 2013-04-25 08:00:05 IST ---

Created attachment 739642 [details]
Screenshot for Issue

Blue Underline - Rendering is Correct
Red Underline  - Rendering has issue

(sorry for delay in screenshot)

--- Additional comment from Jon Ciesla on 2013-04-25 20:37:01 IST ---

Alright, based on that I'm guessing harfbuzz.

--- Additional comment from Jens Petersen on 2013-04-26 06:56:17 IST ---

Probably we should not be using GNU Free for Hindi then?

Alam: other Indic scripts/langs are not affected??

--- Additional comment from Jens Petersen on 2013-04-26 09:02:58 IST ---

Presumably switching gedit to Lohit Devanagari fixes the rendering there.

--- Additional comment from Jens Petersen on 2013-04-26 09:15:13 IST ---

(In reply to comment #5)
> Presumably switching gedit to Lohit Devanagari fixes the rendering there.

Actually doesn't seem to be any Preferences UI now in gedit.

--- Additional comment from Pravin Satpute on 2013-04-26 10:49:13 IST ---

Created attachment 740222 [details]
FreeSans rendering issues with Harfbuzz NG

This is problem with FreeSans rather than Harfbuzz. Please check text 

"प्रविण सातपुते क्षत्रिय क्रियांये " with Lohit Devanagari for correct rendering.

Its probem with Rakara feature, if time permits i will provide patch for this.

--- Additional comment from A S Alam on 2013-04-26 19:31:25 IST ---

(In reply to comment #4)
> Probably we should not be using GNU Free for Hindi then?
> 
> Alam: other Indic scripts/langs are not affected??

I can confirm Punjabi (Gurmukhi) has issues, other Pravin can confirm.

--- Additional comment from A S Alam on 2013-04-26 23:22:14 IST ---

Created attachment 740561 [details]
pref for gedit

Please click (or right click) on gedit icon (which is close to Activities in gnome-shell) and you can get preferences.

--- Additional comment from Akira TAGOH on 2013-05-02 12:52:36 IST ---

need to have similar recipe for FreeSans like this for FreeSerif:
http://pkgs.fedoraproject.org/cgit/gnu-free-fonts.git/commit/?id=a6e0de29c2bd9663fd38bf54c4f26fef5507252a

--- Additional comment from Pravin Satpute on 2013-05-09 10:45:28 IST ---

Created attachment 745547 [details]
Modified lohit devanagari conf file

After modifying lohit fontconf now i am getting
 
$fc-match serif:lang=hi
$fc-match sans-serif:lang=hi
$fc-match monospace:lang=hi
 
 
But still gnome-shell "activities" showing me FreeSans in output. Just wondering from where it is coming.

--- Additional comment from Pravin Satpute on 2013-05-09 16:50:17 IST ---

Created attachment 745617 [details]
screenshot showing gnu-free-sans getting selected in gnome-shell for hi

--- Additional comment from Pravin Satpute on 2013-05-09 16:51:34 IST ---

Created attachment 745621 [details]
expected output, gnome-shell should select lohit as a default font
Comment 1 Pravin Satpute 2013-05-15 06:32:28 EDT
I will provide patch to fix this in upstream or Fedora. 

This issues is specifically for invalid rendering of some Devanagari syllable using FreeSans.
Comment 2 Pravin Satpute 2013-05-16 04:38:08 EDT
Created attachment 748662 [details]
patch to fix rendering issue.

I have reported this problem in upstream as well. So if upstream is quick we can wait for there release, else will be good to build this with locale fedora patch.
Comment 3 Pravin Satpute 2013-05-16 04:39:25 EDT
upstream bug is https://savannah.gnu.org/bugs/index.php?39007
Comment 4 Steve White 2013-05-16 04:59:37 EDT
Hi, your friendly GNU FreeFont admin here.

This is a known problem, which has been repaired some time ago in SVN.

The 2012 release of GNU FreeFont was tested with Pango and Win XP, by native speakers and by myself. The font shaping engine of Windows Vista and 7 is substantially different from that of XP, and it was known at the time of the previous release that this change resulted in wrong rendering in those systems, much like the one described here.

Harfbuzz emulates these newer Windows shaping engines, and so the problem arises there.

One of the main thrusts in FreeFont over the past year has been to re-engineer the lookup tables to work with the newer font renderers.

As to when a new release will happen: I don't know -- soon, I hope.  Some ranges of the font are not in a deliverable state at this time.  I'll renew my efforts on this.

I'll continue the discussion in the GNU FreeFont bug report.

Cheers!
Comment 5 Pravin Satpute 2013-05-16 06:56:51 EDT
Thanks Steve for update and fixing this issue in upstream. Expecting soon next release from you :)
Comment 6 Pravin Satpute 2013-06-24 05:44:50 EDT
Hi Jon,

  I think next upstream release will take some more time. I checked with the upstream svn for the fix of this bug. Patch given by me match with fix in upstream.

  It will be good if you can build gnu-free-fonts with the patch provided in comment #2, so that we can get gnu-free-fonts issues fixed release in Fedora 19.

  Spec file for quick build with above patch is available http://pravins.fedorapeople.org/gnu-free-fonts.spec
Comment 7 Steve White 2013-06-24 07:43:02 EDT
Hi Pravin,

You are right in that the FreeFont release cannot be expected within the next month or so.  There are just too many issues in progress at this time.

The patch is the right way to go.
Comment 8 Fedora Update System 2013-06-24 09:19:31 EDT
gnu-free-fonts-20120503-7.fc19 has been submitted as an update for Fedora 19.
https://admin.fedoraproject.org/updates/gnu-free-fonts-20120503-7.fc19
Comment 9 Fedora Update System 2013-06-24 14:50:33 EDT
Package gnu-free-fonts-20120503-7.fc19:
* should fix your issue,
* was pushed to the Fedora 19 testing repository,
* should be available at your local mirror within two days.
Update it with:
# su -c 'yum update --enablerepo=updates-testing gnu-free-fonts-20120503-7.fc19'
as soon as you are able to.
Please go to the following url:
https://admin.fedoraproject.org/updates/FEDORA-2013-11605/gnu-free-fonts-20120503-7.fc19
then log in and leave karma (feedback).
Comment 10 Fedora Update System 2013-07-02 21:42:41 EDT
gnu-free-fonts-20120503-7.fc19 has been pushed to the Fedora 19 stable repository.  If problems still persist, please make note of it in this bug report.